<!-- HTML header for doxygen 1.8.8-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <!-- For Mobile Devices -->
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
        <meta name="generator" content="Doxygen 1.8.13"/>
        <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.1.min.js"></script>
        <title>libinput: Seats</title>
        <!--<link href="tabs.css" rel="stylesheet" type="text/css"/>-->
        <script type="text/javascript" src="dynsections.js"></script>
        <script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
        <link href="doxygen.css" rel="stylesheet" type="text/css" />
        <link href="bootstrap.css" rel="stylesheet" type="text/css"/>
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
<link href="libinputdoxygen.css" rel="stylesheet" type="text/css"/>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.1/js/bootstrap.min.js"></script>
        <script type="text/javascript" src="doxy-boot.js"></script>
    </head>
    <body>
        <nav class="navbar navbar-default" role="navigation">
            <div class="container">
                <div class="navbar-header">
                    <a class="navbar-brand">libinput 1.10.4</a>
                </div>
            </div>
        </nav>
        <div id="top"><!-- do not remove this div, it is closed by doxygen! -->
            <div class="content" id="content">
                <div class="container">
                    <div class="row">
                        <div class="col-sm-12 panel panel-default" style="padding-bottom: 15px;">
                            <div style="margin-bottom: 15px;">
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="general.html">General</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Seats </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Each device in libinput is assigned to one seat.</p>
<p>A seat has two identifiers, the physical name and the logical name. The physical name is summarized as the list of devices a process on the same physical seat has access to. The logical seat name is the seat name for a logical group of devices. A compositor may use that to create additional seats as independent device sets. Alternatively, a compositor may limit itself to a single logical seat, leaving a second compositor to manage devices on the other logical seats.</p>
<h1><a class="anchor" id="Overview"></a>
Overview</h1>
<p>Below is an illustration of how physical seats and logical seats interact:</p>
<p><div class="dotgraph">
<img src="dot_seats-sketch.png" alt="dot_seats-sketch.png" border="0" usemap="#dot_seats-sketch.map"/>
<map name="dot_seats-sketch.map" id="dot_seats-sketch.map"><area shape="rect" id="node2" href="structlibinput__event.html" title="event0" alt="" coords="227,389,313,437"/>
<area shape="rect" id="node3" href="structlibinput__event.html" title="event1" alt="" coords="337,389,424,437"/>
<area shape="rect" id="node4" href="structlibinput__event.html" title="event2" alt="" coords="448,389,535,437"/>
<area shape="rect" id="node5" href="structlibinput__event.html" title="event3" alt="" coords="559,389,645,437"/>
<area shape="rect" id="node6" href="group__seat.html#gac881036869846ad87eb7814fbf308251" title="phys seat0" alt="" coords="318,293,443,341"/>
<area shape="rect" id="node7" href="group__seat.html#gac881036869846ad87eb7814fbf308251" title="phys seat1" alt="" coords="539,293,665,341"/>
<area shape="rect" id="node11" href="structlibinput.html" title="libinput context 1" alt="" coords="285,197,477,245"/>
<area shape="rect" id="node12" href="structlibinput.html" title="libinput context 2" alt="" coords="506,197,698,245"/>
<area shape="rect" id="node8" href="group__seat.html#ga61e477120d5f0cc67a06d04575186948" title="logical seat A" alt="" coords="153,101,304,149"/>
<area shape="rect" id="node9" href="group__seat.html#ga61e477120d5f0cc67a06d04575186948" title="logical seat B" alt="" coords="328,101,479,149"/>
<area shape="rect" id="node10" href="group__seat.html#ga61e477120d5f0cc67a06d04575186948" title="logical seat C" alt="" coords="526,101,678,149"/>
</map>
</div>
</p>
<p>The devices "Foo", "Bar" and "Spam" share the same physical seat and are thus available in the same libinput context. Only "Foo" and "Bar" share the same logical seat. The device "Egg" is not available in the libinput context associated with the physical seat 0.</p>
<p>The above graph is for illustration purposes only. In libinput, a struct <a class="el" href="structlibinput__seat.html">libinput_seat</a> comprises both physical seat and logical seat. From a caller's point-of-view the above device layout is presented as:</p>
<p><div class="dotgraph">
<img src="dot_seats-sketch-libinput.png" alt="dot_seats-sketch-libinput.png" border="0" usemap="#dot_seats-sketch-libinput.map"/>
<map name="dot_seats-sketch-libinput.map" id="dot_seats-sketch-libinput.map"><area shape="rect" id="node1" href="structlibinput.html" title="libinput context 1" alt="" coords="135,197,327,245"/>
<area shape="rect" id="node2" href="structlibinput.html" title="libinput context 2" alt="" coords="550,197,742,245"/>
</map>
</div>
</p>
<p>Thus, devices "Foo" and "Bar" both reference the same struct <a class="el" href="structlibinput__seat.html">libinput_seat</a>, all other devices reference their own respective seats.</p>
<h1><a class="anchor" id="seats_and_features"></a>
The effect of seat assignment</h1>
<p>A logical set is interpreted as a group of devices that usually belong to a single user that interacts with a computer. Thus, the devices are semantically related. This means for devices within the same logical seat:</p>
<ul>
<li>if the same button is pressed on different devices, the button should only be considered logically pressed once.</li>
<li>if the same button is released on one device, the button should be considered logically down if still down on another device.</li>
<li>if two different buttons or keys are pressed on different devices, the logical state is that of both buttons/keys down.</li>
<li>if a button is pressed on one device and another device moves, this should count as dragging.</li>
<li>if two touches are down on different devices, the logical state is that of two touches down.</li>
</ul>
<p>libinput provides functions to aid with the above: <a class="el" href="group__event__pointer.html#ga1990b268bdc42ff3277bc43dbb3102ea" title="For the button of a LIBINPUT_EVENT_POINTER_BUTTON event, return the total number of buttons pressed o...">libinput_event_pointer_get_seat_button_count()</a>, <a class="el" href="group__event__keyboard.html#ga75a647f08ef9df9db7a6ebb9b297add4" title="For the key of a LIBINPUT_EVENT_KEYBOARD_KEY event, return the total number of keys pressed on all de...">libinput_event_keyboard_get_seat_key_count()</a>, and <a class="el" href="group__event__touch.html#gabac75c78a0a360995e1a521edb38c4da" title="Get the seat slot of the touch event. ">libinput_event_touch_get_seat_slot()</a>.</p>
<p>Internally, libinput counts devices within the same logical seat as related. Cross-device features only activate if all required devices are in the same logical seat. For example, libinput will only activate the top software buttons (see <a class="el" href="t440_support.html">Lenovo *40 series touchpad support</a>) if both trackstick and touchpad are assigned to the same logical seat.</p>
<h1><a class="anchor" id="changing_seats"></a>
Changing seats</h1>
<p>A device may change the logical seat it is assigned to at runtime with <a class="el" href="group__device.html#ga9f76acc43c8684a13f232073ee829b50" title="Change the logical seat associated with this device by removing the device and adding it to the new s...">libinput_device_set_seat_logical_name()</a>. The physical seat is immutable and may not be changed.</p>
<p>Changing the logical seat for a device is equivalent to unplugging the device and plugging it back in with the new logical seat. No device state carries over across a logical seat change. </p>
</div></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.8-->
<!-- start footer part -->
</div>
</div>
</div>
</div>
</div>
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
